"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const React = require("react");
const reactRouterDom = require("react-router-dom");
const core = require("@react-params/core");
const ReactRouterApiProvider = ({ children }) => {
  var _a;
  const router = (_a = React.useContext(reactRouterDom.UNSAFE_DataRouterContext)) == null ? void 0 : _a.router;
  const api = React.useMemo(() => {
    return {
      getSearch: () => {
        if (core.isServer && location) {
          return location.search;
        } else if (router) {
          return router.state.location.search;
        }
        throw new Error("No router or location");
      },
      replaceState: (params, state) => {
        router == null ? void 0 : router.navigate(params, {
          replace: true,
          state
        });
      },
      pushState: (params, state) => {
        router == null ? void 0 : router.navigate(params, {
          replace: false,
          state
        });
      },
      registerListener: (listener) => {
        router == null ? void 0 : router.subscribe((action) => {
          const { state: navigationState } = action.navigation;
          if (navigationState !== "idle") {
            return;
          }
          const { state } = action.location;
          listener(state);
        });
      }
    };
  }, [router]);
  return /* @__PURE__ */ React.createElement(core.ApiContext.Provider, { value: api }, children);
};
exports.ReactRouterApiProvider = ReactRouterApiProvider;
//# sourceMappingURL=react-router.cjs.map
