import React, { useContext, useMemo } from "react";
import { UNSAFE_DataRouterContext } from "react-router-dom";
import { isServer, ApiContext } from "@react-params/core";
const ReactRouterApiProvider = ({ children }) => {
  var _a;
  const router = (_a = useContext(UNSAFE_DataRouterContext)) == null ? void 0 : _a.router;
  const api = useMemo(() => {
    return {
      getSearch: () => {
        if (isServer && location) {
          return location.search;
        } else if (router) {
          return router.state.location.search;
        }
        throw new Error("No router or location");
      },
      replaceState: (params, state) => {
        router == null ? void 0 : router.navigate(params, {
          replace: true,
          state
        });
      },
      pushState: (params, state) => {
        router == null ? void 0 : router.navigate(params, {
          replace: false,
          state
        });
      },
      registerListener: (listener) => {
        router == null ? void 0 : router.subscribe((action) => {
          const { state: navigationState } = action.navigation;
          if (navigationState !== "idle") {
            return;
          }
          const { state } = action.location;
          listener(state);
        });
      }
    };
  }, [router]);
  return /* @__PURE__ */ React.createElement(ApiContext.Provider, { value: api }, children);
};
export {
  ReactRouterApiProvider
};
//# sourceMappingURL=react-router.js.map
